﻿/*
*	ExMobi4.0 JS 框架之 动态树类tree.js(依赖base.js)
*	Version	:	1.0.0.4
*	Author	:	Nandy Wong
*	Email	:	huangnan@nj.fiberhome.com.cn
*	Weibo   :   http://weibo.com/nandy007
*   Copyright 2012 (c) 南京烽火星空通信发展有限公司
*/
//两个参数，第一个是初始化数据为json格式，第二个为源数据，当为json格式的时候认为是ptree，当为xml的时候认为是xtree
function $tree(treeId,isExpandAll){
	var tree = document.getElementById(treeId);
	if(!tree) return null;
	//初始化树节点的属性，用json对象是为了后续可以扩充
	tree.init = {
					target:"_blank",
					collapsetarget:"_self",
				};
	//缓存append的数据
	var cacheData = [];
	
	//提供直接返回json对象或者数组直接写树
	tree.load = function(data){
		data = (typeof data)=="string"?data.toJSON():data;
		data = (data instanceof Array)?data:[data];
		data = data.sort(function(x,y){
			if(x.pId==y.id) return 1; //升序
		});
		var rs = [];
		window.beignPreferenceChange();
		for(var i=0;i<data.length;i++){
			data[i].id = data[i].id?data[i].id:tree.encryption();
			data[i].pId = data[i].pId?data[i].pId:treeId;
			tree.add(data[i].id, data[i].pId, data[i].text, data[i].value, data[i].href, data[i].collapsehref,data[i].iscollapse,data[i].checkbox,data[i].checkboxhref);
			rs.push({"id":data[i].id, "pId":data[i].pId, "text":data[i].text, "value":data[i].value, "href":data[i].href, "collapsehref":data[i].collapsehref, "iscollapse":data[i].iscollapse, "checkbox":data[i].checkbox,"checkboxhref":data[i].checkboxhref});
		}
		window.endPreferenceChange();
		return rs;
	};
	//该方法不暴露，为树添加节点
	tree.add = function(id, pId, text, value, href, collapsehref,iscollapse,checkbox,checkboxhref){
		var parentItem = tree.getTreeItemById(pId);
		if(!parentItem) return null;
		var newItem = tree.getTreeItemById(id)?tree.getTreeItemById(id):new TreeItem();
		newItem.id = id;
		newItem.text = text;
		newItem.value = value;
		if(href){
			newItem.href = href;
			newItem.target = tree.init.target;
		}
		if(collapsehref){
			newItem.collapsehref = collapsehref;
			newItem.collapsetarget = tree.init.collapsetarget;
		}
		newItem.iscollapse = iscollapse;
		newItem.checkbox = checkbox;
		newItem.checkboxhref = checkboxhref;
		if(!tree.getTreeItemById(id)) parentItem.addTreeItem(newItem);
		newItem.child = function(itemId, itemText, itemValue, itemHref, itemCollapsehref,itemIscollapse,itemCheckbox,checkboxhref){
			return tree.add(itemId, newItem.id, itemText, itemValue, itemHref, itemCollapsehref,itemIscollapse,itemCheckbox,itemCheckboxhref);
		};
		return newItem;
	};
	//为树追加节点
	tree.append = function(id, pId, text, value, href, collapsehref){
		id = id?id:tree.encryption();
		pId = pId?pId:treeId;
		var item = {"id":id,"pId":pId,"text":text,"value":value,"href":href,"collapsehref":collapsehref};
		cacheData.push(item);
		return item;
	};
	//当使用append追加节点的时候必须通过该方法写树
	tree.show = function(){
		tree.load(cacheData);
		cacheData = [];
	};
	//根据id获取树节点
	tree.get = function(){
		var treeItem = (typeof arguments[0])=="object"?arguments[0]:tree.getTreeItemById(arguments[0]);
		treeItem.id = treeItem.id?treeItem.id:tree.encryption();
		//给某个节点添加子节点
		treeItem.child = function(itemId, itemText, itemValue, itemHref, itemCollapsehref){
			return tree.add(itemId, treeItem.id, itemText, itemValue, itemHref, itemCollapsehref);
		};
		//将某个节点从树节点中删除
		treeItem.remove = function(){
			tree.removeItemById(treeItem.id);
		};
		treeItem.clear = function(){
			for(var i=treeItem.childNodes.length-1;i>-1;i--){
				tree.remove(treeItem.childNodes[i]);
			}
		};
		//树是否有子节点
		treeItem.hasChild = function(id){
			return treeItem.childNodes==0?false:true;
		}
		return treeItem;
	};
	//给某个节点添加节点
	tree.child = function(id, text, value, href, collapsehref){
		return tree.add(id, treeId, text, value, href, collapsehref);
	};
	//移除树节点
	tree.remove = function(){
		var id = (typeof arguments[0])=="string"?arguments[0]:arguments[0].id;
		if(id) tree.removeItemById(id);
	}
	//获取随机id
	tree.encryption = function(){
	    var date = new Date();
	    var times1970 = date.getTime();
	    var times = date.getDate() + "" + date.getHours() + "" + date.getMinutes() + "" + date.getSeconds();
	    var encrypt = times * times1970;
	    if(arguments.length == 1){
	        return arguments[0] + encrypt;
	    }else{
	        return encrypt;
	    }
	}
	
	//返回的是树对象，可以对该对象操作标准树对象的所有JS，比如打开关闭节点
	return tree;
}
